#if !defined (GISMO_USAGE)
#define GISMO_USAGE

#include <config.h>

#define GISMO_VERSION "\
  ----------------------------------------------------\n\
  GISMO " PACKAGE_VERSION " by " PACKAGE_BUGREPORT "\n\
  " PACKAGE_URL "\n\
  Copyright 2015-2020 The University of Maryland\n\
  Freely distributed under the MIT License\n\
  ----------------------------------------------------\n"

#define USAGE_GISMO "\
Gibbs Sampler for Multi-alignment Optimization\n\n\
Usage: " PACKAGE_NAME " fastafile [options]\n\
  options:\n\
\t-h=<int>        - Number of initial block-based alignments = N (2 to 50: default 2)\n\
\t-H=<int>        - Number of candidate HMM alignments (2 to 50: default 2)\n\
\t-iters=<int>    - Add/remove column interations in stages 2 to 4 (1 to 5: default 3)\n\
\t-L              - Mask low complexity regions (default: off)\n\
\t-maxseq=<int>   - Set the maximum number of input sequences (default: 20,000)\n\
\t-thrds=<int>    - Use multithreading with <int> threads (range: 2 to 100; default: 1)\n\
\t                  Note: the best alignment among the threads will be saved.\n\
\t-rtf            - Also output a MS-Word-viewable rich text file (*.rtf)\n\
\t-seed=<int>     - Random seed\n\
\t-stages=<int>   - Specify the number of sampling stages (2 to 4: default 2)\n\
  References:\n\
    Neuwald, A.F. Parallelized Version of GISMO for Multiple Sequence\n\
      Alignment. (In preparation).\n\n\
    Neuwald, A.F and S. F. Altschul. 2016. Bayesian Top-down Protein\n\
      Sequence Alignment with Inferred Position-Specific Gap Penalties.\n\
      Plos Comp. Biol. 12(5): e1004936\n\
    Neuwald A.F. and Liu J.S. 2004. Gapped alignment of protein sequence motifs\n\
      through Monte Carlo optimization of a hidden Markov model.\n\
      BMC Bioinformatics 5: 157 \n\
  Funding:\n\
    National Institutes of Health, National Library of Medicine grant LM06747\n\
     and National Institute of General Medical Sciences grant R01GM125878.\n\
"

#endif

